Cordova/PhoneGap VGuard Plugin
==============================

Installation
------------

```
1. cordova plugin add path-to-folder/com-vkey-vguard
2. Add voscodesign.vky file please refer `Appendix - Generate voscodesign.vky file` on VGuard Developer Guide.

```

Supported platforms
-------------------

-	Android
-	iOS

VGuard Initalization iOS
------------------------

No need aditioanl implementaion, everyting handle by vguard plugin, using AppDelegate+vguard.m class

##VGuard Initalization Android

```javascript
document.addEventListener("deviceReady", onDeviceReady, false);

function onDeviceReady() {
   startVGuard();
}

function startVGuard() {
	window.vguardplugin.setupVGuard(
		onVGuardInitialize,
		onVosReady,
		onScanComplete,
		onVGuardError
	);
}

function onVGuardInitialize() {
	console.log("onVGuardInitialize..");
}

function onVosReady(returncode) {
	if(returncode) {
		console.log("onVosReady.. " + returncode);
	}
}

function onScanComplete(threats) {
	if(threats) {
		for(var i=0; i<threats.length; i++) {
			var threat = threats[i];
			console.log("onScanComplete.. threat class: " + threat.threatClass
			+ ", threat name: " + threat.threatName + ", threat info: " + threat.threatInfo);
		}
	}
}

function onVGuardError(vgerror) {
	if(vgerror) {
		console.warn("onVGuardError.. " + vgerror);
	}
}
```

#### Using VGuard with Android API level 23 (Android 6) or higher

The VGuard framework uses the permission 'android.permission.SYSTEM_ALERT_WINDOW' and since Android API level 23 (Android 6) it throws an exception in side loaded applications. The applications are installed through the play store, will have granted the permission automatically.

Therefore need to enable "Draw over other apps" in development time. 1. Go to the Device Settings 2. Tap "Apps" 3. On the top right, tap the gear icon 4. Under Advanced, chose "Draw over other apps" 5. Find App in the list and tap it 6. Toggle "Permit drawing over other apps" to ON.

Main modules

Secure Preferences
------------------

#### Usage:

```javascript
var sp = window.vguardspplugin.openPreferences();

sp.spput(
  function(msg) {
    console.log("sp.spput  my_key, my_value :" + msg);
  },
  errorcb, "my_key", "my_value");

sp.spget(
  function(msg) {
    console.log("sp.get  my_key :" + msg);
  },
  errorcb, "my_key");

sp.spremove(
  function(msg) {
    console.log("sp.spremove  my_key :" + msg);
  },
  errorcb, "my_key");

sp.spcontainskey(
  function(msg) {
    console.log("sp.spcontainskey  my_key :" + msg);
  },
  errorcb, "my_key");

sp.spclear(
  function(msg) {
    console.log("sp.spclear :" + msg);
  },
  errorcb);

```

Secure SQLite
-------------

#### Usage:

##### Open a database

```javascript
// open sqlite database
var db = window.vguardsqlitePlugin.openDatabase(
  {name: 'test_sqlite.db', location: 'default'},
  function(msg) {
    if(msg) {
      console.log("`test_sqlite.db` is open.. successcb: " + msg);
    }
  },
  function(msg) {
    if(msg) {
      console.log("errorcb: " + msg);
    }
  });
```

##### Creating a table

```javascript
db.transaction(
    function(tx) {
      tx.executeSql('DROP TABLE IF EXISTS test_table');
      tx.executeSql('CREATE TABLE IF NOT EXISTS test_table'
        + ' (id integer primary key autoincrement, data text, data_num real)');
    },
    function(error) {
      console.log('transaction error: ' + error.message);
  },
  function() {
      console.log('transaction ok, created table `test_table`');
  }
);
```

##### Adding data

```javascript
function addData() {
	  // open sqlite database
	  var db = window.vguardsqlitePlugin.openDatabase(
	  	{name: 'test_sqlite.db', location: 'default'},
	  	function(msg) {
	  		if(msg) {
	  			console.log("`test_sqlite.db` is open.. successcb: " + msg);
	  		}
	  	},
	  	function(msg) {
	  		if(msg) {
	  			console.log("errorcb: " + msg);
	  		}
	  	});

	  // insert data
	  db.executeSql(
	  	  "INSERT INTO test_table (data, data_num) VALUES (?,?)", ["Cheetah", 10.0],
	  	  function (resultSet) {
  			  console.log('resultSet.insertId: ' + resultSet.insertId);
  			  console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
		  },
		  function(error) {
  			  console.log('insert error: ' + error.message);
		  }
		);

	  db.transaction(
	  	  function(tx) {
	  		tx.executeSql(
	  	  		"INSERT INTO test_table (data, data_num) VALUES (?,?)", ["Puma", 10.1],
	  	  		function (tx, resultSet) {
  			  		console.log('resultSet.insertId: ' + resultSet.insertId);
  			  		console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
		  		},
		  		function(tx, error) {
  			  		console.log('insert error: ' + error.message);
		  		}
			);
	  		tx.executeSql(
	  	  		"INSERT INTO test_table (data, data_num) VALUES (?,?)", ["Jaguar", 10.2],
	  	  		function (tx, resultSet) {
  			  		console.log('resultSet.insertId: ' + resultSet.insertId);
  			  		console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
		  		},
		  		function(tx, error) {
  			  		console.log('insert error: ' + error.message);
		  		}
			);
	  		tx.executeSql(
	  	  		"INSERT INTO test_table (data, data_num) VALUES (?,?)", ["Panther", 10.3],
	  	  		function (tx, resultSet) {
  			  		console.log('resultSet.insertId: ' + resultSet.insertId);
  			  		console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
		  		},
		  		function(tx, error) {
  			  		console.log('insert error: ' + error.message);
		  		}
			);
	  		tx.executeSql(
	  	  		"INSERT INTO test_table (data, data_num) VALUES (?,?)", ["Tiger", 10.4],
	  	  		function (tx, resultSet) {
  			  		console.log('resultSet.insertId: ' + resultSet.insertId);
  			  		console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
		  		},
		  		function(tx, error) {
  			  		console.log('insert error: ' + error.message);
		  		}
			);
	  		tx.executeSql(
	  	  		"INSERT INTO test_table (data, data_num) VALUES (?,?)", ["Leopard", 10.5],
	  	  		function (tx, resultSet) {
  			  		console.log('resultSet.insertId: ' + resultSet.insertId);
  			  		console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
		  		},
		  		function(tx, error) {
  			  		console.log('insert error: ' + error.message);
		  		}
			);
	  		tx.executeSql(
	  	  		"INSERT INTO test_table (data, data_num) VALUES (?,?)", ["Snow Leopard", 10.6],
	  	  		function (tx, resultSet) {
  			  		console.log('resultSet.insertId: ' + resultSet.insertId);
  			  		console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
		  		},
		  		function(tx, error) {
  			  		console.log('insert error: ' + error.message);
		  		}
			);
	  		tx.executeSql(
	  	  		"INSERT INTO test_table (data, data_num) VALUES (?,?)", ["Lion", 10.7],
	  	  		function (tx, resultSet) {
  			  		console.log('resultSet.insertId: ' + resultSet.insertId);
  			  		console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
		  		},
		  		function(tx, error) {
  			  		console.log('insert error: ' + error.message);
		  		}
			);																	
	  	  },
	  	  function(error) {
  			  console.log('transaction error: ' + error.message);
		  },
		  function() {
  			  console.log('transaction ok');
		  }
	  );
}
```

##### Getting data

```javascript
function getData() {
	var log = "";

	  // open sqlite database
	  var db = window.vguardsqlitePlugin.openDatabase(
	  	{name: 'test_sqlite.db', location: 'default'},
	  	function(msg) {
	  		if(msg) {
	  			console.log("`test_sqlite.db` is open.. successcb: " + msg);
	  		}
	  	},
	  	function(msg) {
	  		if(msg) {
	  			console.log("errorcb: " + msg);
	  		}
	  	});		

	db.executeSql(
		"SELECT * FROM test_table", [],
	 	 function (resultSet) {
	  	 	if(resultSet && resultSet.rows) {
	  	  		for(var i=0; i<resultSet.rows.length; i++) {
	  	  	 		console.log('resultSet:- '
	  	  	 		+ "data:" + resultSet.rows.item(i).data
	  	  	 		+ ", data_num:" + resultSet.rows.item(i).data_num);

	  	  	 		if(log.length > 0) {
	  	  	 			log += "\n";
	  	  	 		}
	  	  	 		log += "os: " + resultSet.rows.item(i).data
	  	  	 			+ ", version: " + resultSet.rows.item(i).data_num;
	  	  	 	}
	  	  	 	alert(log);
	  	  	 }
	  	  	 else {
	  	  	 	alert("No records found..");
	  	  	 }
		 },
		 function(error) {
  			console.log('SELECT error: ' + error.message);
		 }
	);		
}
```

##### Updating data

```javascript
function updateData() {
	  // open sqlite database
	  var db = window.vguardsqlitePlugin.openDatabase(
	  	{name: 'test_sqlite.db', location: 'default'},
	  	function(msg) {
	  		if(msg) {
	  			console.log("`test_sqlite.db` is open.. successcb: " + msg);
	  		}
	  	},
	  	function(msg) {
	  		if(msg) {
	  			console.log("errorcb: " + msg);
	  		}
	  	});

	  // update data
	  db.transaction(
	  	  function(tx) {
	  		tx.executeSql(
	  	  		"UPDATE test_table SET data = ? WHERE id = ?", ["Mountain Lion", 1],
	  	  		function (tx, resultSet) {
  			  		console.log('resultSet.insertId: ' + resultSet.insertId);
  			  		console.log('resultSet.rowsAffected: ' + resultSet.rowsAffected);
		  		},
		  		function(tx, error) {
  			  		console.log('insert error: ' + error.message);
		  		}
			);
	  	  },
	  	  function(error) {
  			  console.log('transaction error: ' + error.message);
		  },
		  function() {
  			  console.log('transaction ok');
		  }
	  );
}
```

##### Deleting a database

```javascript
function deleteDb() {
	  // open sqlite database
	  var db = window.vguardsqlitePlugin.openDatabase(
	  	{name: 'test_sqlite.db', location: 'default'},
	  	function(msg) {
	  		if(msg) {
	  			console.log("`test_sqlite.db` is open.. successcb: " + msg);
	  		}
	  	},
	  	function(msg) {
	  		if(msg) {
	  			console.log("errorcb: " + msg);
	  		}
	  	});

	  // close database
	  db.close(
	  	  function() {
	  		  console.log('database is closed ok');
	  	  },
	  	  function(errorcb) {
	  	  	  console.log('ERROR closing database');
	  	  }
	  );

	  // delete database
	  window.vguardsqlitePlugin.deleteDatabase(
	  	  {name: 'test_sqlite.db', location: 'default'},
	  	  function() {
	  	  	  console.log('database was deleted');
	  	  },
	  	  function(errorcb) {
	  	  	console.log('ERROR deleting database');
	  	  }
	  );	  
}
```

Secure File IO
--------------

##### Creating a file

```javascript
function createFile() {
    window.VGRequestFileSystem (
        VGLocalFileSystem.PERSISTENT,
        0,
        function (fs) {
            console.log('file system open: ' + fs.name);
            fs.root.getFile("newPersistentFile.txt", { create: true, exclusive: false },
                function (fileEntry) {
                    console.log("fileEntry is file?" + fileEntry.isFile.toString());
                    fileEntry.createWriter(
                        function (fileWriter) {
                            fileWriter.onwriteend = function() {
                                console.log("Successful file write...");
                            };

                            fileWriter.onerror = function (e) {
                                console.log("Failed file write: " + e.toString());
                            };

                            // If data object is not passed in,
                            // create a new Blob instead.
                            var dataObj = new Blob(['hello world! this file is encrypted..'], { type: 'text/plain' });
                            fileWriter.write(dataObj);
                        }
                    );
                },
                onErrorCreateFile
            );
        },
        onErrorLoadFs
    );
}

function onErrorCreateFile() {
    console.log("onErrorCreateFile...");
}

function onErrorLoadFs(vgfileError) {
    console.log("onErrorLoadFs..." + ((vgfileError)? vgfileError.code : ""));
}
```

##### Reading a file

```javascript
function readFile() {
    window.VGRequestFileSystem (
        VGLocalFileSystem.PERSISTENT,
        0,
        function (fs) {
            console.log('file system open: ' + fs.name);
            fs.root.getFile("newPersistentFile.txt", { create: false, exclusive: false },
                function (fileEntry) {
                    console.log("fileEntry is file?" + fileEntry.isFile.toString());

                    fileEntry.file(
                        function (file) {
                            var reader = new VGFileReader();

                            reader.onloadend = function() {
                                console.log("Successful file read: " + this.result);
                                alert(this.result);
                            };

                            reader.readAsText(file);
                        },
                        onErrorReadFile
                    );

                },
                onErrorCreateFile
            );
        },
        onErrorLoadFs
    );   
}

function onErrorReadFile() {
    console.log("onErrorReadFile...");
}
```

##### Creating directories

```javascript
function createDirs() {
    window.VGRequestFileSystem (
        VGLocalFileSystem.PERSISTENT,
        0,
        function (fs) {
            console.log('file system open: ' + fs.name);

            fs.root.getDirectory(
                'NewDirInRoot',
                { create: true },
                function (dirEntry) {
                    dirEntry.getDirectory(
                        'images',
                        { create: true },
                        function (subDirEntry) {
                            //createFile(subDirEntry, "fileInNewSubDir.txt");
                        },
                        onErrorGetDir
                    );
                },
                onErrorGetDir
            );          
        },
        onErrorLoadFs
    );
}

function onErrorGetDir() {
    console.log("onErrorGetDir...");
}
```

##### Downloading and saving an image

```javascript
function secureFileEncImageTest() {

    window.VGRequestFileSystem (
        VGLocalFileSystem.PERSISTENT,
        0,
        function (fs) {
            console.log('file system open: ' + fs.name);

            var xhr = new XMLHttpRequest();
            xhr.open('GET', 'http://cordova.apache.org/static/img/cordova_bot.png', true);
            xhr.responseType = 'blob';

            xhr.onload = function() {
                if (this.status == 200) {
                    var blob = new Blob([this.response], { type: 'image/png' });
                    saveFile(fs.root, blob, "downloadedImage.png");
                }
            };
            xhr.send();   
        },
        onErrorLoadFs
    );
}

function saveFile(dirEntry, fileData, fileName) {
    dirEntry.getFile(
        fileName,
        { create: true, exclusive: false },
        function (fileEntry) {
            fileEntry.createWriter(
                function (fileWriter) {
                    fileWriter.onwriteend = function() {
                        console.log("Successful file write...");
                    };
                    fileWriter.onerror = function (e) {
                        console.log("Failed file write: " + e.toString());
                    };
                    fileWriter.write(fileData);
                }
            );
        },
        onErrorCreateFile
    );   
}
```

##### Showing a downloaded and encrypted image

```javascript
function secureFileDecImageTest() {
    window.VGRequestFileSystem (
        VGLocalFileSystem.PERSISTENT,
        0,
        function (fs) {
            console.log('file system open: ' + fs.name);
            fs.root.getFile(
                "downloadedImage.png",
                { create: false, exclusive: false },
                function (fileEntry) {
                    console.log("fileEntry is file?" + fileEntry.isFile.toString());
                    fileEntry.file(
                        function (file) {
                            var reader = new VGFileReader();
                            reader.onloadend = function() {
                                console.log("Successful file read: " + this.result);

                                var blob = new Blob([new Uint8Array(this.result)], { type: "image/png" });
                                // secure_file_io_dec_image_view should be available in HTML file
                                var elem = document.getElementById('secure_file_io_dec_image_view');

                                elem.src = window.URL.createObjectURL(blob);
                            };
                            reader.readAsArrayBuffer(file);
                        },
                        onErrorReadFile
                    );
                },
                onErrorCreateFile
            );
        },
        onErrorLoadFs
    );   
}
```
