//
//  VGuardSPPlugin.m
//  helloworldcordova
//
//  Created by Damith Hettige on 29/8/16.
//
//
#import <VGuard/NSUserDefaults.h>
#import "VGuardSpPlugin.h"

@implementation VGuardSpPlugin

- (void)act_sp_get:(CDVInvokedUrlCommand *)command{
    [self.commandDelegate runInBackground:^{
        NSString *key = [command.arguments objectAtIndex:0];
        CDVPluginResult *pluginResult;
        if (key && key.length>0 && [key isKindOfClass:[NSString class]]) {
            id obj = [self objectForKey:key];
            pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:obj];
        }else{
            pluginResult = [CDVPluginResult resultWithStatus: CDVCommandStatus_ERROR messageAsString:@"Key is null or not a string"];
        }
        [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
    }];
}

- (void)act_sp_put:(CDVInvokedUrlCommand *)command{
    [self.commandDelegate runInBackground:^{
        NSString *key = [command.arguments objectAtIndex:0];
        id value = [command.arguments objectAtIndex:1];
        CDVPluginResult *pluginResult;
        if (key && key.length>0 && [key isKindOfClass:[NSString class]]) {
            if (value && [value isKindOfClass:[NSString class]]) {
                [self setObject: value forKey: key];
                pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:@"1"];
            }else {
                pluginResult = [CDVPluginResult resultWithStatus: CDVCommandStatus_ERROR messageAsString:@"Value is null or not a string"];
            }
        }else{
            pluginResult = [CDVPluginResult resultWithStatus: CDVCommandStatus_ERROR messageAsString:@"Key is null or not a string"];
        }
        [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
    }];
}

- (void)act_sp_remove:(CDVInvokedUrlCommand *)command {
    [self.commandDelegate runInBackground:^{
        NSString *key = [command.arguments objectAtIndex:0];
        CDVPluginResult *pluginResult;
        if (key && key.length>0 && [key isKindOfClass:[NSString class]]) {
            [self setObject: @"" forKey: key];
            pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:@"1"];
        }else{
            pluginResult = [CDVPluginResult resultWithStatus: CDVCommandStatus_ERROR messageAsString:@"Key is null or not a string"];
        }
        [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
    }];
}

- (void)act_sp_contains_key:(CDVInvokedUrlCommand *)command{
    [self.commandDelegate runInBackground:^{
        NSString *key = [command.arguments objectAtIndex:0];
        CDVPluginResult *pluginResult;
        if (key && key.length>0 && [key isKindOfClass:[NSString class]]) {
            id obj = [self objectForKey:key];
            NSString *contain = @"0";
            if (obj && ![obj isEqualToString:@""]){
                contain = @"1";
            }
            pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:contain];
        }else{
            pluginResult = [CDVPluginResult resultWithStatus: CDVCommandStatus_ERROR messageAsString:@"Key is null or not a string"];
        }
        [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
    }];
}

- (void)act_sp_clear:(CDVInvokedUrlCommand *)command{
    [self.commandDelegate sendPluginResult:[CDVPluginResult resultWithStatus: CDVCommandStatus_NO_RESULT messageAsString:@"iOS not supported"] callbackId:command.callbackId];
}


#pragma Mark - Util Methods
- (id)objectForKey:(NSString *)defaultName{
    return [[NSUserDefaults standardUserDefaults] objectForKey_vg:defaultName];
}

- (void)setObject:(id)value forKey:(NSString *)defaultName{
    [[NSUserDefaults standardUserDefaults] setObject_vg:value forKey:defaultName];
}


@end
