/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

/**
 * VGFileError
 */
function VGFileError(error) {
  this.code = error || null;
}

// File error codes
// Found in DOMException
VGFileError.NOT_FOUND_ERR = 1;
VGFileError.SECURITY_ERR = 2;
VGFileError.ABORT_ERR = 3;

// Added by File API specification
VGFileError.NOT_READABLE_ERR = 4;
VGFileError.ENCODING_ERR = 5;
VGFileError.NO_MODIFICATION_ALLOWED_ERR = 6;
VGFileError.INVALID_STATE_ERR = 7;
VGFileError.SYNTAX_ERR = 8;
VGFileError.INVALID_MODIFICATION_ERR = 9;
VGFileError.QUOTA_EXCEEDED_ERR = 10;
VGFileError.TYPE_MISMATCH_ERR = 11;
VGFileError.PATH_EXISTS_ERR = 12;
VGFileError.VOS_NOT_STARTED = 100;

module.exports = VGFileError;
