/*
 * (C) Copyright 2016 V-Key Solutions.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Contributors:
 *     	Damith Hettige
 * 		Rukmal Dias
 */

(function() {
	var root, VGuardSecureKeyboard;
  	root = this;
	  
	/**
     * Constructor
     */
  	SecureKeyboard = function() {
  	};
	  	
  	/**
  	 * Constants
  	 */
  	var CONST = {
  		PLG_NAME : "SecureKeyboard",
  		ACT_TEST : "act_test",
  	};
  	
  	/**
  	 * Saves key, value in secure preferences
	 * @param {Object} message
  	 */
  	SecureKeyboard.prototype.test = function(successcb, errorcb, message) {
	  	cordova.exec(
	  		function (success) {
	  			if(successcb) {
	  				successcb(success);
	  			}
	  		}, 
	  		function (error) {
	  			if(errorcb) {
	  				errorcb(error);
	  			}
	  		},
	  		CONST.PLG_NAME, 
	  		CONST.ACT_TEST,
	  		[message]);
	};
				  	
	VGKeyboardFactory = {
		initializeKeybaord : function() {
			return new SecureKeyboard();
		}
	};
  	
	root.securekeyboard = {
		initializeKeybaord : VGKeyboardFactory.initializeKeybaord
	};
  
}).call(this);