var argscheck = require('cordova/argscheck'),
	utils = require('cordova/utils'),
	exec = require('cordova/exec');

VGuardPlugin = function () {};

/**
 * Constants
 */
var CONST = {
	PLG_NAME: "VGuardPlugin",
	ACT_SETUP_VGUARD: "act_setup_vguard",
	ACT_START_VGUARD: "act_start_vguard",
	ACT_VERSION_VGUARD: "act_version_vguard",

	ACT_ENABLE_KEYBOARD: "act_enable_Keyboard",
	ACT_ENABLE_SCRAMBLE_KEYPAD: "act_enable_ScrambleKeypad",
	ACT_SET_KEYPAD_BUTTON_ALPHA: "act_set_keypad_button_alpha",
	ACT_SET_KEYPAD_BUTTON_BACKGROUND_COLOR: "act_set_keypad_button_background_color",
	ACT_SET_KEYPAD_TEXT_COLOR: "act_set_keypad_text_color"
};

/**
 * Starts VGuard service
 * @param {Function} onVGuardSuccess
 * @param {Function} onVGuardFailed
 */
VGuardPlugin.prototype.setupVGuard = function (onSuccess, onError) {
	cordova.exec(
		// successcb
		function (successcbmsg) {
			if (successcbmsg) {
				var msg = successcbmsg;
				console.log("setupVGuard: successcb");
				console.log("-- on vGuard initialize");
				if (onSuccess) {
					onSuccess(msg);
				}
			}
		},

		// errorcb
		function (errorcbmsg) {
			if (errorcbmsg) {
				var msg = errorcbmsg;
				console.log("setupVGuard errorcb : " + errorcbmsg.values);
				console.warn("-- on vGuard error");
				if (onError) {
					onError(msg);
				}
			}
		},
		CONST.PLG_NAME,
		CONST.ACT_SETUP_VGUARD, []
	);
};

VGuardPlugin.prototype.start = function (onSuccess, onError) {
	cordova.exec(
		// successcb
		function (successcbmsg) {
			if (successcbmsg) {
				var msg = successcbmsg;
				console.log("start vGuard: success");
				console.log("-- on vGuard start");
				if (onSuccess) {
					onSuccess(msg);
				}
			}
		},

		// errorcb
		function (errorcbmsg) {
			if (errorcbmsg) {
				var msg = errorcbmsg;
				console.log("start vGuard errorcb : " + errorcbmsg.values);
				console.warn("-- on vGuard start error");
				if (onError) {
					onError(msg);
				}
			}
		},
		CONST.PLG_NAME,
		CONST.ACT_START_VGUARD, []
	);
};

VGuardPlugin.prototype.version = function (onSuccess, onError) {
	cordova.exec(
		// successcb
		function (successcbmsg) {
			if (successcbmsg) {
				var msg = successcbmsg;
				console.log("start vGuard: success");
				console.log("-- on vGuard start");
				if (onSuccess) {
					onSuccess(msg);
				}
			}
		},

		// errorcb
		function (errorcbmsg) {
			if (errorcbmsg) {
				var msg = errorcbmsg;
				console.log("start vGuard errorcb : " + errorcbmsg.values);
				console.warn("-- on vGuard start error");
				if (onError) {
					onError(msg);
				}
			}
		},
		CONST.PLG_NAME,
		CONST.ACT_VERSION_VGUARD, []
	);
};

VGuardPlugin.prototype.enableKeyboard = function (successcb, errorcb, enable) {
	exec(
		function (success) {
			if (successcb) {
				successcb(success);
			}
		},
		function (error) {
			if (errorcb) {
				errorcb(error);
			}
		},
		CONST.PLG_NAME,
		CONST.ACT_ENABLE_KEYBOARD, [enable]);
};

VGuardPlugin.prototype.enableScrambleKeypad = function (successcb, errorcb, enable) {
	exec(
		function (success) {
			if (successcb) {
				successcb(success);
			}
		},
		function (error) {
			if (errorcb) {
				errorcb(error);
			}
		},
		CONST.PLG_NAME,
		CONST.ACT_ENABLE_SCRAMBLE_KEYPAD, [enable]);
};

VGuardPlugin.prototype.setKeypadButtonAlpha = function (successcb, errorcb, alpha) {
	exec(
		function (success) {
			if (successcb) {
				successcb(success);
			}
		},
		function (error) {
			if (errorcb) {
				errorcb(error);
			}
		},
		CONST.PLG_NAME,
		CONST.ACT_SET_KEYPAD_BUTTON_ALPHA, [alpha]);
};

VGuardPlugin.prototype.setKeypadButtonBackgroundColor = function (successcb, errorcb, color) {
	exec(
		function (success) {
			if (successcb) {
				successcb(success);
			}
		},
		function (error) {
			if (errorcb) {
				errorcb(error);
			}
		},
		CONST.PLG_NAME,
		CONST.ACT_SET_KEYPAD_BUTTON_BACKGROUND_COLOR, [color]);
};

VGuardPlugin.prototype.setKeypadTextColor = function (successcb, errorcb, color) {
	exec(
		function (success) {
			if (successcb) {
				successcb(success);
			}
		},
		function (error) {
			if (errorcb) {
				errorcb(error);
			}
		},
		CONST.PLG_NAME,
		CONST.ACT_SET_KEYPAD_TEXT_COLOR, [color]);
};

module.exports = new VGuardPlugin();